﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Windows.Threading;

namespace XamDataGridGroupsIndentation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void GroupByRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as GroupByRecordPresenter).Margin = new Thickness(-18 * (sender as GroupByRecordPresenter).Record.NestingDepth, 0, 0, 0);
        }

        private void DataRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            if ((sender as DataRecordPresenter).IsHeaderRecord && (sender as DataRecordPresenter).FieldLayout.SortedFields.CountOfGroupByFields!=0)
            {
                (sender as DataRecordPresenter).Margin = new Thickness(-17 * (sender as DataRecordPresenter).FieldLayout.SortedFields.CountOfGroupByFields, 0, 0, 0);
            }
        }
    }

    public class DPMarginConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((values[1] as DataRecordPresenter).Record != null)
            {
                return new Thickness(-17 * (values[1] as DataRecordPresenter).FieldLayout.SortedFields.CountOfGroupByFields, 0, 0, 0);
            }
            return Binding.DoNothing;
            
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
